/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the parameters for using CDN managed certificate for securing custom
 * domain.
 *
 */
class CdnCertificateSourceParameters {
  /**
   * Create a CdnCertificateSourceParameters.
   * @property {string} certificateType Type of certificate used. Possible
   * values include: 'Shared', 'Dedicated'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CdnCertificateSourceParameters
   *
   * @returns {object} metadata of CdnCertificateSourceParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CdnCertificateSourceParameters',
      type: {
        name: 'Composite',
        className: 'CdnCertificateSourceParameters',
        modelProperties: {
          odatatype: {
            required: true,
            isConstant: true,
            serializedName: '@odata\\.type',
            defaultValue: '#Microsoft.Azure.Cdn.Models.CdnCertificateSourceParameters',
            type: {
              name: 'String'
            }
          },
          certificateType: {
            required: true,
            serializedName: 'certificateType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CdnCertificateSourceParameters;
