/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The JSON object that contains the properties to secure a custom domain.
 *
 */
class CustomDomainHttpsParameters {
  /**
   * Create a CustomDomainHttpsParameters.
   * @property {string} protocolType Defines the TLS extension protocol that is
   * used for secure delivery. Possible values include: 'ServerNameIndication',
   * 'IPBased'
   * @property {string} certificateSource Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomDomainHttpsParameters
   *
   * @returns {object} metadata of CustomDomainHttpsParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomDomainHttpsParameters',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'certificateSource',
          clientName: 'certificateSource'
        },
        uberParent: 'CustomDomainHttpsParameters',
        className: 'CustomDomainHttpsParameters',
        modelProperties: {
          protocolType: {
            required: true,
            serializedName: 'protocolType',
            type: {
              name: 'String'
            }
          },
          certificateSource: {
            required: true,
            serializedName: 'certificateSource',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomDomainHttpsParameters;
